/* programa potencial.c
   Calcula el potential total creado por una distribución de cargas 
   el radio de cada carga (rc) es igual a 0.1 
*/

#include <stdio.h>
#include <math.h>

double V(double x1, double x2, double x3, double rc, double * rx, double * ry, double * rz, double * Q, int N) {
int s; 
double V1, d;
V1 = 0.0;  
 for (s=0;s<N;s++) {
   d = sqrt(pow((x1-rx[s]),2)+pow((x2-ry[s]),2)+pow((x3-rz[s]),2));
    if(d>rc) 
     V1 = V1 - 1.0*Q[s]/d;
    else
     V1 = V1 - 1.0*Q[s]/rc;
  }
return V1;
}



int main()
{
int i, j, k, N;
int Grid_size=100;
double x, rc;
double ui,uj,uk;
double xmin;
xmin = -5.0;
rc = 0.1;

  FILE * chargeinput;
  chargeinput = fopen("charges.dat","r");
  FILE * potoutput;
  potoutput = fopen("potencial-3d.dat","w");

  fscanf(chargeinput,"%d",&N);
  printf("Numero de cargas: %d \n",N);

  double rx[N], ry[N], rz[N], Q[N];  
  for(i=0;i<N;i++) {
  fscanf(chargeinput,"%lf %lf %lf %lf",&Q[i],&rx[i],&ry[i],&rz[i]); 
  printf("Carga: %lf  Posicion: %lf %lf %lf \n",Q[i],rx[i],ry[i],rz[i]);
  }


for(i=0;i<Grid_size;i++)
   {
    ui = (2.0*xmin)*((double)i-(double)Grid_size/2.0)/(double)Grid_size;	
      for(j=0;j<Grid_size;j++)
	{
	uj = (2.0*xmin)*((double)j-(double)Grid_size/2.0)/(double)Grid_size;	
          for(k=0;k<Grid_size;k++) {
           uk = (2.0*xmin)*((double)k-(double)Grid_size/2.0)/(double)Grid_size;	
           x = V(ui,uj,uk,rc,rx,ry,rz,Q,N) ;
	   fprintf(potoutput,"%.10lf \n",x);
          }	
	}
   }

  fclose(chargeinput);
  fclose(potoutput);

return 0;
}
